﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Documents.Excel;
using Infragistics.Controls.Grids;
using Microsoft.Win32;
using System.IO;
using Infragistics.Controls.Grids.Primitives;

namespace xamGridExcelExport1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void ExportButton_Click(object sender, RoutedEventArgs e)
        {
            // Create workbook
            Workbook workbook1 = new Workbook();

            // Add worksheet
            Worksheet worksheet1 = workbook1.Worksheets.Add("Sample Worksheet1");
            int nextRowIndex = 0;

            ExportRows(worksheet1, this.xamGrid1.Columns, this.xamGrid1.Rows, nextRowIndex);

            // Create Save File Dialog
            SaveFileDialog savefileDialog = new SaveFileDialog { Filter = "Excel files|*.xls", DefaultExt = "xls" };

            // Display the dialog. If the user selects a file of the correct format 
            // and clicks Save in the dialog, save the file using the Save method of the Workbook object.
            if (savefileDialog.ShowDialog() == true)
            {
                Stream stream = savefileDialog.OpenFile();
                workbook1.Save(stream);
                stream.Close();
            }

        }

        private void ExportRows(Worksheet worksheet1, ColumnBaseCollection columnCollection, RowCollection rowCollection, int nextRowIndex)
        {
            WorksheetRow worksheetRow;
            Column gridColumn;
            WorksheetCell worksheetHeaderCell;

            foreach (Row gridRow in rowCollection)
            {
                worksheetRow = worksheet1.Rows[nextRowIndex];

                // Export cells for category
                for (int columnIndex = 0; columnIndex < columnCollection.Count - 1; columnIndex++)
                {
                    /* Set header appearance and text */
                    if (gridRow.Index == 0)
                    {
                        worksheetHeaderCell = worksheet1.Rows[nextRowIndex].Cells[columnIndex];
                        gridColumn = columnCollection[columnIndex] as Column;
                        worksheetHeaderCell.CellFormat.Font.Bold = ExcelDefaultableBoolean.True;
                        worksheetHeaderCell.Value = gridColumn.Key;

                        if (columnIndex == columnCollection.Count - 1)
                        {
                            nextRowIndex++;
                        }
                    }

                    worksheetRow = worksheet1.Rows[nextRowIndex + 1];
                    // Set Excel cell value to xamGrid's cell value cell by cell
                    worksheetRow.Cells[columnIndex].Value = gridRow.Cells[columnIndex].Value;
                }

                nextRowIndex += 2;

                if (gridRow.ChildBands.Count > 0)
                {
                    foreach (Row childRow in gridRow.ChildBands[0].Rows)
                    {
                        // Export cells for product
                        for (int columnIndex = 0; columnIndex < gridRow.ChildBands[0].Columns.Count - 1; columnIndex++)
                        {
                            /* Set header appearance and text */
                            if (childRow.Index == 0)
                            {
                                worksheetHeaderCell = worksheet1.Rows[nextRowIndex].Cells[columnIndex];
                                worksheetHeaderCell.CellFormat.Font.Bold = ExcelDefaultableBoolean.True;
                                worksheetHeaderCell.Value = gridRow.ChildBands[0].Columns[columnIndex].Key;

                                if (columnIndex == gridRow.ChildBands[0].Columns.Count - 1)
                                {
                                    nextRowIndex++;
                                }
                            }

                            worksheetRow = worksheet1.Rows[nextRowIndex + 1];
                            // Set Excel cell value to xamGrid's cell value cell by cell
                            worksheetRow.Cells[columnIndex].Value = childRow.Cells[columnIndex].Value;
                        }
                        nextRowIndex++;
                    }
                }

                nextRowIndex++;
            }
        }
    }
}
